{ lib, ... }:

{
  options.deployment = with lib; {
    vcpu = mkOption {
      type = types.int;
    };
    mem = mkOption {
      type = types.int;
    };
    hypervisor = mkOption {
      type = types.enum [
        "qemu"
        "cloud-hypervisor"
        "firecracker"
        "crosvm"
        "kvmtool"
      ];
    };
    networks = mkOption {
      type = with types; listOf str;
    };
    persistedShares = mkOption {
      type = with types; listOf str;
    };
    extraShares = mkOption {
      type = with types; listOf (submodule {
        options = {
          source = mkOption {
            type = str;
          };
          mountPoint = mkOption {
            type = str;
          };
        };
      });
    };
    needForSpeed = mkOption {
      type = types.bool;
    };
  };
}
